<?php
// Credit Louviaux Jean-Marc 2015
define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);

if (isset($_COOKIE['user_lang'])) {
    $user_lang = $_COOKIE['user_lang'];
} else {
    $user_lang = "English";
}

include("../languages/" . $user_lang . ".php");

function tricsv($var)
{
    return !is_dir($var) && preg_match('/\.csv$/i', $var);
}

$latestfile = 0;
for ($invt_num = 1; $invt_num <= $NUMINV; $invt_num++) { // Check files dates
    $dir    = '../data/invt' . $invt_num . '/csv';
    $output = scandir($dir);
    $output = array_filter($output, "tricsv");
    sort($output);
    $cnt                    = count($output);
    $year                   = substr($output[$cnt - 1], 0, 4);
    $month                  = substr($output[$cnt - 1], 4, 2);
    $day                    = substr($output[$cnt - 1], 6, 2);
    $fileUTCdate[$invt_num] = strtotime($year . "-" . $month . "-" . $day);
    if ($fileUTCdate[$invt_num] > $latestfile) {
        $latestfile     = $fileUTCdate[$invt_num];
        $latestfilename = $output[$cnt - 1];
    }
}

$year  = date('Y', $latestfile);
$month = date('m', $latestfile);
$day   = date('d', $latestfile);

$todayUTC = strtotime(date("Ymd"));

$MaxPow    = 0;
$MaxTime   = 0;
$LastTime  = 0;
$activeint = $NUMINV;
for ($invt_num = 1; $invt_num <= $NUMINV; $invt_num++) { // multi
    include("../config/config_invt$invt_num.php");
    $dir      = '../data/invt' . $invt_num . '/csv/';
    $filename = $dir . $latestfilename;
    if (${'SKIPMONITORING' . $invt_num} || !file_exists($filename)) {
        $activeint--;
    }
}

for ($invt_num = 1; $invt_num <= $NUMINV; $invt_num++) { // multi
    $dir      = '../data/invt' . $invt_num . '/csv/';
    $filename = $dir . $latestfilename;
    if (file_exists($filename)) { // skip older day files
        include("../config/config_invt$invt_num.php");
        
        $line_num = 1;
        if ($handle = fopen("$filename", 'r')) {
            while ($line = fgetcsv($handle, 1000, ',')) {
                if ($line_num > 1) {
                    
                    $SDTE[$line_num] = $line[0];
                    $KWHT[$line_num] = $line[27];
                    
                    if ($line_num == 2) {
                        $pastline_num = 2;
                    } else {
                        $pastline_num = $line_num - 1;
                    }
                    
                    $hour        = substr($SDTE[$line_num], 0, 2);
                    $minute      = substr($SDTE[$line_num], 3, 2);
                    $seconde     = substr($SDTE[$line_num], 6, 2);
                    $pasthour    = substr($SDTE[$pastline_num], 0, 2);
                    $pastminute  = substr($SDTE[$pastline_num], 3, 2);
                    $pastseconde = substr($SDTE[$pastline_num], 6, 2);
                    
                    $UTC = strtotime($year . "-" . $month . "-" . $day . " " . $hour . ":" . $minute . ":" . $seconde);
                    
                    $diffUTCdate        = strtotime($year . "-" . $month . "-" . $day . " " . $pasthour . ":" . $pastminute . ":" . $pastseconde);
                    $diffTime           = $UTC - $diffUTCdate;
                    $UTCdate[$invt_num] = $UTC * 1000;
                    
                    if ($diffTime != 0) {
                        $AvgPOW[$invt_num] = round((((($KWHT[$line_num] - $KWHT[$pastline_num]) * 3600) / $diffTime) * 1000), 1);
                        if (!isset($CumPOW[$hour . $minute])) {
                            $CumPOW[$hour . $minute] = 0;
                        }
                        $CumPOW[$hour . $minute] += $AvgPOW[$invt_num];
                        $sampledate[$hour . $minute][$invt_num] = strtotime($year . "-" . $month . "-" . $day . " " . $hour . ":" . $minute);
                        if ($CumPOW[$hour . $minute] >= $MaxPow) { // Past maximum
                            $MaxPow  = $CumPOW[$hour . $minute];
                            $MaxTime = $sampledate[$hour . $minute][$invt_num] * 1000;
                        }
                        $cnt = count($sampledate[$hour . $minute]);
                        if ($sampledate[$hour . $minute][$invt_num] > $LastTime && $cnt == $activeint) {
                            $LastTime  = $sampledate[$hour . $minute][$invt_num]; // Last sample in common
                            $LastValue = $CumPOW[$hour . $minute];
                        }
                    } else {
                        $AvgPOW[$invt_num] = 0;
                    }
                }
                $line_num++;
            }
            fclose($handle);
        }
        
        $UTCdate[$invt_num] = $sampledate[$hour . $minute][$invt_num] * 1000;
        $line_num--;
        $KWHD[$invt_num] = round((($KWHT[$line_num] - $KWHT[2]) * ${'CORRECTFACTOR' . $invt_num}), 1);
    } else { // skip older file
        $KWHD[$invt_num] = 0;
    }
} // multi

$KWHDTOT = 0;
for ($invt_num = 1; $invt_num <= $NUMINV; $invt_num++) {
    if (!isset($fileUTCdate[$invt_num])) {
        $fileUTCdate[$invt_num] = 0;
    }
    if ($fileUTCdate[$invt_num] == $latestfile) {
        $KWHDTOT += $KWHD[$invt_num];
    }
}

$KWHDTOT = round($KWHDTOT, 1);
$KWHDTOT = number_format($KWHDTOT, 1, $DPOINT, $THSEP);

$LastTime *= 1000;
if ($MaxTime == 0) {
    $MaxTime = $LastTime;
}

if ($latestfile == $todayUTC) {
    $PTITLE = stripslashes("$lgTODAYTITLE ($KWHDTOT kWh)");
} elseif ($latestfile == strtotime(date("Ymd", strtotime("-1 day")))) {
    $PTITLE = stripslashes("$lgYESTERDAYTITLE ($KWHDTOT kWh)");
} else {
    $dday   = date($DATEFORMAT, $latestfile);
    $PTITLE = stripslashes("$dday ($KWHDTOT kWh)");
}

$data[0] = array(
    'totTime' => $LastTime,
    'totValue' => $LastValue
);

for ($invt_num = 1; $invt_num <= $NUMINV; $invt_num++) { // Multi
    if ($fileUTCdate[$invt_num] == $latestfile) {
        $data[$invt_num] = array(
            'x' => $UTCdate[$invt_num],
            'y' => $AvgPOW[$invt_num]
        );
    } else {
        $data[$invt_num] = array(
            'x' => $LastTime,
            'y' => 0
        );
    }
} // multi

$data[$invt_num] = array(
    'MaxTime' => $MaxTime,
    'MaxPow' => $MaxPow
);
$invt_num++;
$data[$invt_num] = array(
    'LastTime' => $LastTime,
    'LastValue' => $LastValue
);
$invt_num++;
$data[$invt_num] = array(
    'PTITLE' => $PTITLE
);
header("Content-type: text/json");
echo json_encode($data);
?>
